using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;

namespace MecabDicCostEditer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonGetOrgFileName_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                this.textOrgFileName.Text = ofd.FileName;
            }
        }

        private void buttonGetDescFileName_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                this.textDestFileName.Text = sfd.FileName;
            }
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            this.textLog.Clear();
            Encoding encode = Encoding.GetEncoding(this.comboBoxEncode.Text);

            StreamReader sr = new StreamReader(this.textOrgFileName.Text, encode);
            string str = sr.ReadToEnd();
            sr.Close();

            double a = double.Parse(this.textCost.Text);

            string[] lines = str.Split('\n');
            List<string> newLines = new List<string>();
            foreach (string line in lines)
            {
                Regex regex = this.radioWordIsDirect.Checked
                    ? new Regex("^" + this.textWord.Text + ",")
                    : new Regex(this.textWord.Text);

                if (regex.IsMatch(line))
                {                  
                    string[] elements = line.Split(',');
                    int cost = int.Parse(elements[3]);
                    int newCost = (int)(radioCostIsAbsolute.Checked ? a : a * cost);

                    this.textLog.Text += elements[0] + " : " + cost.ToString() + "  " + newCost.ToString() + "\r\n";

                    elements[3] = newCost.ToString();

                    newLines.Add(string.Join(",", elements));
                }
                else
                {
                    newLines.Add(line);
                }
            }

            string destFileName = this.checkFileIsSame.Checked
                ? this.textOrgFileName.Text
                : this.textDestFileName.Text;
            StreamWriter sw = new StreamWriter(destFileName, false, encode);
            sw.Write(string.Join("\n", newLines.ToArray()));
            sw.Close();

            this.textLog.Text += "";
            MessageBox.Show("I");

        }

        private void checkFileIsSame_CheckedChanged(object sender, EventArgs e)
        {
            bool enabled = !this.checkFileIsSame.Checked;
            this.textDestFileName.Enabled = enabled;
            this.buttonGetDestFileName.Enabled = enabled;
        }
    }
}